> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.schoolset.io/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.schoolset.io/_mcp/server.

# Create a report-card course

POST https://ssuccessv2.com/app/api/v1/courses
Content-Type: application/json

Creates a course and optionally synchronizes its audiences and teachers for selected academic years.

Reference: https://docs.schoolset.io/api-reference/school-set-api/courses/create-course

## Authentication

- `Authorization` header (bearer token, required) — The signed-in SchoolSet user token sent by the frontend.

## Request

### Body (application/json)

This endpoint expects an object.

- `subject_id` (integer, required)
- `name` (string, required)
- `sort_order` (integer, optional)
- `period_length_minutes` (integer, optional)
- `times_per_week` (integer, optional)
- `duration_weeks` (integer, optional)
- `sync_year_ids` (list of integer, optional)
- `audiences` (list of ApiV1CoursesPostRequestBodyContentApplicationJsonSchemaAudiencesItems, optional)
- `teachers` (list of ApiV1CoursesPostRequestBodyContentApplicationJsonSchemaTeachersItems, optional)

## Response

### 200

Course created.

- `status` (string, optional)
- `message` (string, optional)
- `data` (ApiV1CoursesPostResponsesContentApplicationJsonSchemaData, optional)

## Errors

### 401 Unauthorized Error

Authentication required.

- `status` (string, required)
- `message` (string, required)
- `data` (any, optional, nullable)

### 403 Forbidden Error

The user cannot create subjects and courses.

- `status` (string, required)
- `message` (string, required)
- `data` (any, optional, nullable)

### 422 Unprocessable Entity Error

Course fields or related audience/teacher IDs failed validation.

- `message` (string, required)
- `errors` (map from string to list of string, required)

## Types

### ApiV1CoursesPostRequestBodyContentApplicationJsonSchemaAudiencesItems

- `year_id` (integer, required)
- `audience_type` (enum, required)
  - Allowed values: `grade`, `class`
- `audience_id` (integer, required)

### ApiV1CoursesPostRequestBodyContentApplicationJsonSchemaTeachersItems

- `year_id` (integer, required)
- `staff_member_id` (integer, required)

### ApiV1CoursesPostResponsesContentApplicationJsonSchemaData

- `id` (integer, optional)

## Examples

**Request**

```json
{
  "subject_id": 4,
  "name": "Algebra I",
  "sort_order": 1,
  "period_length_minutes": 45,
  "times_per_week": 5,
  "duration_weeks": 36,
  "sync_year_ids": [
    2025
  ],
  "audiences": [
    {
      "year_id": 2025,
      "audience_type": "grade",
      "audience_id": 9
    }
  ],
  "teachers": [
    {
      "year_id": 2025,
      "staff_member_id": 33
    }
  ]
}
```

**Response**

```json
{
  "status": "success",
  "message": "Course created.",
  "data": {
    "id": 18
  }
}
```

**SDK Code**

```python Courses_createCourse_example
import requests

url = "https://ssuccessv2.com/app/api/v1/courses"

payload = {
    "subject_id": 4,
    "name": "Algebra I",
    "sort_order": 1,
    "period_length_minutes": 45,
    "times_per_week": 5,
    "duration_weeks": 36,
    "sync_year_ids": [2025],
    "audiences": [
        {
            "year_id": 2025,
            "audience_type": "grade",
            "audience_id": 9
        }
    ],
    "teachers": [
        {
            "year_id": 2025,
            "staff_member_id": 33
        }
    ]
}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript Courses_createCourse_example
const url = 'https://ssuccessv2.com/app/api/v1/courses';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"subject_id":4,"name":"Algebra I","sort_order":1,"period_length_minutes":45,"times_per_week":5,"duration_weeks":36,"sync_year_ids":[2025],"audiences":[{"year_id":2025,"audience_type":"grade","audience_id":9}],"teachers":[{"year_id":2025,"staff_member_id":33}]}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go Courses_createCourse_example
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://ssuccessv2.com/app/api/v1/courses"

	payload := strings.NewReader("{\n  \"subject_id\": 4,\n  \"name\": \"Algebra I\",\n  \"sort_order\": 1,\n  \"period_length_minutes\": 45,\n  \"times_per_week\": 5,\n  \"duration_weeks\": 36,\n  \"sync_year_ids\": [\n    2025\n  ],\n  \"audiences\": [\n    {\n      \"year_id\": 2025,\n      \"audience_type\": \"grade\",\n      \"audience_id\": 9\n    }\n  ],\n  \"teachers\": [\n    {\n      \"year_id\": 2025,\n      \"staff_member_id\": 33\n    }\n  ]\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Courses_createCourse_example
require 'uri'
require 'net/http'

url = URI("https://ssuccessv2.com/app/api/v1/courses")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"subject_id\": 4,\n  \"name\": \"Algebra I\",\n  \"sort_order\": 1,\n  \"period_length_minutes\": 45,\n  \"times_per_week\": 5,\n  \"duration_weeks\": 36,\n  \"sync_year_ids\": [\n    2025\n  ],\n  \"audiences\": [\n    {\n      \"year_id\": 2025,\n      \"audience_type\": \"grade\",\n      \"audience_id\": 9\n    }\n  ],\n  \"teachers\": [\n    {\n      \"year_id\": 2025,\n      \"staff_member_id\": 33\n    }\n  ]\n}"

response = http.request(request)
puts response.read_body
```

```java Courses_createCourse_example
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://ssuccessv2.com/app/api/v1/courses")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"subject_id\": 4,\n  \"name\": \"Algebra I\",\n  \"sort_order\": 1,\n  \"period_length_minutes\": 45,\n  \"times_per_week\": 5,\n  \"duration_weeks\": 36,\n  \"sync_year_ids\": [\n    2025\n  ],\n  \"audiences\": [\n    {\n      \"year_id\": 2025,\n      \"audience_type\": \"grade\",\n      \"audience_id\": 9\n    }\n  ],\n  \"teachers\": [\n    {\n      \"year_id\": 2025,\n      \"staff_member_id\": 33\n    }\n  ]\n}")
  .asString();
```

```php Courses_createCourse_example
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://ssuccessv2.com/app/api/v1/courses', [
  'body' => '{
  "subject_id": 4,
  "name": "Algebra I",
  "sort_order": 1,
  "period_length_minutes": 45,
  "times_per_week": 5,
  "duration_weeks": 36,
  "sync_year_ids": [
    2025
  ],
  "audiences": [
    {
      "year_id": 2025,
      "audience_type": "grade",
      "audience_id": 9
    }
  ],
  "teachers": [
    {
      "year_id": 2025,
      "staff_member_id": 33
    }
  ]
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp Courses_createCourse_example
using RestSharp;

var client = new RestClient("https://ssuccessv2.com/app/api/v1/courses");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"subject_id\": 4,\n  \"name\": \"Algebra I\",\n  \"sort_order\": 1,\n  \"period_length_minutes\": 45,\n  \"times_per_week\": 5,\n  \"duration_weeks\": 36,\n  \"sync_year_ids\": [\n    2025\n  ],\n  \"audiences\": [\n    {\n      \"year_id\": 2025,\n      \"audience_type\": \"grade\",\n      \"audience_id\": 9\n    }\n  ],\n  \"teachers\": [\n    {\n      \"year_id\": 2025,\n      \"staff_member_id\": 33\n    }\n  ]\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift Courses_createCourse_example
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [
  "subject_id": 4,
  "name": "Algebra I",
  "sort_order": 1,
  "period_length_minutes": 45,
  "times_per_week": 5,
  "duration_weeks": 36,
  "sync_year_ids": [2025],
  "audiences": [
    [
      "year_id": 2025,
      "audience_type": "grade",
      "audience_id": 9
    ]
  ],
  "teachers": [
    [
      "year_id": 2025,
      "staff_member_id": 33
    ]
  ]
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://ssuccessv2.com/app/api/v1/courses")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```